=== Plugins/ParametricSurfaces/CMakeLists.txt ===
paraview_add_plugin(ParametricSurfaces
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION             "1.0"
  SERVER_MANAGER_XML  ParametricSurfaces.xml)
